include gui/win32lib/win32lib.ew
include database.e

without warning
with trace

-- Empty grid record
global constant EmptyGridRow = {"", 2, "", "", 0, True}

-- Empty database record
constant EmptyDBRecord = {"", 0, ""}

-- Record field ids
global constant
ANIMAL=1,
NUMBER=2,
NOTES=3,
KEY=4,
RECNO=5,
NEW_RECORD=6

-- Dummy return variable
object void

-- Database functions
global function GetAnimalData ()

	integer key
	sequence dataset, record, msg
	object db_record

	dataset={}

	-- Try and open the database
	if db_open("noah", DB_LOCK_NO) != DB_OK then
		msg = "Unable to open noah.edb! \n"
     			& "\n"
     			& "This program will end"
		void = message_box(msg,"Error",0)
		return False
	end if

	-- Select animal data
	if db_select_table("Animal") != DB_OK then
		void = message_box("Unable to select Animal table","Error",0)
		return False
	end if

  	-- Retrieve data
  	for i = 1 to db_table_size() do

  		--Initialise  records
  		record = EmptyGridRow
  		db_record = db_record_data(i)

  		if sequence(db_record) and length(db_record)>0 then
  			record[ANIMAL] 	= db_record[ANIMAL]
  			record[NUMBER]	= db_record[NUMBER]
  			record[NOTES]	= db_record[NOTES]
  			record[KEY]		= db_record_key(i)
  			record[RECNO]	= i

			dataset = append(dataset, record)
		end if
  	end for

  	dataset = sort(dataset)

  	-- Return dataset
  	return dataset

end function

global function SaveAnimalData( sequence record )

	atom recno
	object newkey, bret
	sequence db_record
	bret=False

    -- Select table
    if db_select_table("Animal") != DB_OK then
        void = message_box("Could not open Animal table!", "Error", MB_OK)
        return False
    end if

    -- Set up database record
    db_record = EmptyDBRecord
    db_record[ANIMAL]	= record[ANIMAL]
    db_record[NUMBER]	= record[NUMBER]
    db_record[NOTES]	= record[NOTES]

    -- Try and find key in table
    recno = db_find_key(record[KEY])

    -- If found then delete record prior to re-add (as db_replace_data not working on win2k???)
    if recno > 0 then
    	--db_replace_data(recno, db_record)
       	--bret=record[KEY]
    	db_delete_record(recno)
	end if


    -- Add new record
    if True then
    	-- Select table
    	if db_select_table("IDSequence") != DB_OK then
        	void = message_box("Could not open IDSequence table!", "Error", MB_OK)
        	return False
        else
        	recno = db_find_key("ID")
        	if recno > 0 then
        		newkey = db_record_data(recno)
        		newkey = newkey+1
    			db_delete_record(recno)
				if db_insert( "ID", newkey) != DB_OK then
					void = message_box("Could not update IDSequence table!", "Error", MB_OK)
        			return False
        		end if
        		--db_replace_data("ID", newkey)
        	else
        		void = message_box("Could not find new key in IDSequence table!", "Error", MB_OK)
        		return False
        	end if

        	-- Select table & insert new row
    		if db_select_table("Animal") != DB_OK then
        		void = message_box("Could not open Animal table!", "Error", MB_OK)
        		return False
    		elsif db_insert( newkey, db_record) = DB_OK then
        		bret=newkey
        	end if
        end if
	end if

	return bret

end function
global function DeleteAnimalData( atom key )

	atom recno
	integer bret
	bret=False

    -- Select table
    if db_select_table("Animal") != DB_OK then
        void = message_box("Could not open Animal table!", "Error", MB_OK)
        return False
    end if

     -- Try and find key in table
    recno = db_find_key(key)

    -- If found then delete record
    if recno > 0 then
       	db_delete_record(recno)
       	bret=True
	end if

	return bret

end function
global procedure CloseAnimalDB()

	db_close()

end procedure
1.21